Ext.define('DSS.addon.WhatToPlay', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	getHeight : function() {
		return this.iDefaultHeight;
	},

	height : '100%',
	grids : {},
	nowFileType : -1, // -1: nothing, 0: current music, 1:
	// current queue
	parentDialog : '',
	rowVolume : null,
	rowRepeat : null,
	rowRestart : null,
	checkVolume : null,
	intVolume : null,
	checkRepeat : null,
	timeSpanRepeat : null,
	checkRestart : null,
	lblNowPlayed : null,
	selectedSong : null,
	selectedQueue : null,
	gridQueue : null,
	macPanel : null,
	arrayActiveRooms : null,
	iDefaultWidth : 150,
	iDefaultHeight : 290,
	nActionType : -1,
	txt2Speech : null,
	comboTextLang : null,
	comboTextVoice : null,
	bIsRadio : false,
	arrayMediaLibrary : null,
	arraySpeechSettings : null,
	btnTestPlay : null,
	mediaGroupsSub : null,
	bVolumeRowIsEnabled : false,
	value : null,
	getRemoteErrorText : function(pObject) {
		if (!dss.isCloudAvaible())
			return _('To use this feature, the my.digitalSTROM app must be configured first.');
		return "";
	},
	preparePlayButton : function(bEnable) {
		if (this.btnTestPlay != null) {
			if (bEnable)
				this.btnTestPlay.enable();
			else
				this.btnTestPlay.disable();
		}
	},
	checkIfSelectedItemIsSingleFile : function(bTestText2SpeechParams) {
		var oSelectionLVL1 = this.grids.lvl1.getSelectionModel().getSelection();
		if (oSelectionLVL1[0] != null) {
			switch (oSelectionLVL1[0].get('_id')) {
			case 0:
				if (this.nowFileType == 0 && this.selectedSong != null) {
					if (this.selectedSong.isRadio != null)
						return !this.selectedSong.isRadio;

					return true;
				} else if (this.nowFileType == 1 && this.selectedQueue != null)
					return false;
				break;

			case 1: // playlists
				oSelectionPlaylist = this.grids.lvlPlaylist.getSelectionModel().getSelection();
				if (oSelectionPlaylist != null && oSelectionPlaylist.length > 0) {
					return false;
				}
				break;

			case 2: // favorites
				oSelectionFavorites = this.grids.lvlFavorites.getSelectionModel().getSelection();
				if (oSelectionFavorites != null && oSelectionFavorites.length > 0) {
					return oSelectionFavorites[0].get('isSingleTrack');
				}
				break;

			case 3: // Media Library
				return true;
				break;
			case 4: // Text2Speech
				return true;
				break;

			case 5: // command
				return false;
				break;
			}
		}
		return false;
	},
	handleRepeatPreviousMusicControl : function() {
		// setup control only for
		// Activity dialog
		var bDisableControl = true;
		var nTime = 0;
		if (this.timeSpanRepeat.getValue()!=null) 
			nTime= parseInt("" + this.timeSpanRepeat.getValue(), 10);
		
		if (this.checkRepeat.checked && (nTime > 0)) {
			// if Repeat music is checked and set, we don't need to test song length
			bDisableControl = false;
		} else {
			// length of Activity can be known only if selected What To Play is single file
			bDisableControl = !this.checkIfSelectedItemIsSingleFile();
			// test what trigger value is selected
			// if "Security" item is selected, we also don't need to check song length

			if (this.dssEditor.editControls.triggers != null)
				if (this.dssEditor.editControls.triggers.getValue().length > 0) {
					// if selected Alarm1..Alarm4,Panic
					if (this.dssEditor.editControls.triggers.getValue()[0].type == 'zone-scene') {
						var oTrigger=this.dssEditor.editControls.triggers.getValue()[0];
						if (dss.staticDataModel.getScene(oTrigger.zone,oTrigger.group,oTrigger.scene).undoable) {
							bDisableControl=false;
							return;
						}						
					}
					// if selected Fire
					if (this.dssEditor.editControls.triggers.getValue()[0].type == 'state-change')
						if (this.dssEditor.editControls.triggers.getValue()[0].name == 'fire') { 
							bDisableControl=false;
							return;
						}
				}
		}

		if (bDisableControl) {
			this.rowRestart.disable();
			this.checkRestart.setValue(false);
		} else {
			this.rowRestart.enable();
		}
	},
	preparePlayExtraControls : function(nCommand) {
		switch (nCommand) {
			default: // enable all
				this.rowVolume.enable();
				this.bVolumeRowIsEnabled = true;
				this.rowRepeat.enable();
				this.rowRestart.enable();
			break;

			case 'play':
			case 'unmute':
				this.rowVolume.enable();
				this.bVolumeRowIsEnabled = true;
				this.rowRepeat.disable();
				this.rowRestart.disable();
			break;

			case 'pause':
			case 'mute':
			case 'stop':
				this.rowVolume.disable();
				this.bVolumeRowIsEnabled = false;
				this.rowRepeat.disable();
				this.rowRestart.disable();
			break;
		}
	},
	defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
		var fIsPassive = false;
		if (record.get('passive') != null)
			if (record.get('passive'))
				fIsPassive = true;
		var fHasNext = false;
		if (record.get('next') == true) {
			fHasNext = true;
		}
		var sReturn = '<table style="height:16px;"><tr>';
		var iColspaceCounter = 3;
		if (fIsPassive) {
			sReturn += '<td style="color:#888888;" colspan="' + iColspaceCounter + '" width="100%">' + record.get('name') + '</td>';
		} else {
			sReturn += '<td colspan="' + iColspaceCounter + '" width="100%">' + record.get('name') + '</td>';
		}
		if (fHasNext) {
			sReturn += '<td>&gt;</td>';
		}
		return sReturn + '</tr></table>';
	},
	initLvl1 : function() {
		if (Ext.data.StoreManager.lookup('whattoplay_lvl1') == null) {
			Ext.create('Ext.data.Store', {
				storeId : 'whattoplay_lvl1',
				fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
		}
		if (Ext.data.StoreManager.lookup('whattoplay_l1Store_' + this.parentDialog) == null) {
			var actions = [ {
				name : _('Now Playing'),
				_id : 0,
				next : true,
				icon : null,
				passive : false
			}, {
				name : _('Sonos Playlist'),
				_id : 1,
				next : true,
				icon : null,
				passive : false
			}, {
				name : _('Sonos Favorites'),
				_id : 2,
				next : true,
				icon : null,
				passive : false
			} ];
			actions.push({
				name : _('Library'),
				_id : 3,
				next : true,
				icon : null,
				passive : false
			});
			actions.push({
				name : _('Text to speech'),
				_id : 4,
				next : true,
				icon : null,
				passive : false
			});
			actions.push({
				name : _("Command"),
				_id : 5,
				next : true,
				icon : null,
				passive : false
			});

			Ext.create('Ext.data.Store', {
				storeId : 'whattoplay_l1Store_' + this.parentDialog,
				fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
			Ext.data.StoreManager.lookup('whattoplay_l1Store_' + this.parentDialog).add(actions);
		}
	},
	initStores : function() {
		try {

			var me = this;

			this.arrayActiveRooms = [];
			var arrayPlayRooms = [];

			for ( var sKey in result.result) {
				var roomID = parseInt("" + result.result[sKey].roomID, 10);
				var notDiscovered = (result.result[sKey].notDiscovered != 'false');
				var disabled = (result.result[sKey].disabled != 'false');
				if (roomID > 0)
					if (!notDiscovered)
						if (!disabled) {
							this.arrayActiveRooms.push(result.result[sKey]);
							var tmpData = new Object({
								'_id' : roomID,
								'name' : dss.staticDataModel.getNameForZone(roomID),
								'next' : true,
								'passive' : false
							});
							arrayPlayRooms.push(tmpData);
						}
			}

			if (Ext.data.StoreManager.lookup('whattoplay_commands') == null) {

				Ext.create('Ext.data.Store', {
					storeId : 'whattoplay_commands',
					fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
					proxy : {
						type : 'memory',
						reader : {
							type : 'json',
							root : 'items'
						}
					}
				});

				var arrayCommands = new Array({
					name : _('Stop'),
					_id : 'stop',
					next : false,
					icon : null,
					passive : false
				}, {
					name : _('Play'),
					_id : 'play',
					next : false,
					icon : null,
					passive : false
				}, {
					name : _('Pause'),
					_id : 'pause',
					next : false,
					icon : null,
					passive : false
				}, {
					name : _('Mute'),
					_id : 'mute',
					next : false,
					icon : null,
					passive : false
				}, {
					name : _('Unmute'),
					_id : 'unmute',
					next : false,
					icon : null,
					passive : false
				});

				Ext.data.StoreManager.lookup('whattoplay_commands').add(arrayCommands);
			}

			if (Ext.data.StoreManager.lookup('whattoplay_txt2speech_voice') == null) {
				Ext.create('Ext.data.Store', {
					storeId : 'whattoplay_txt2speech_voice',
					fields : [ 'id', 'name' ],
					proxy : {
						type : 'memory',
						reader : {
							type : 'json',
							root : 'items'
						}
					}
				});
			} else
				Ext.data.StoreManager.lookup('whattoplay_txt2speech_voice').removeAll();

			Ext.data.StoreManager.lookup('whattoplay_rooms').add(arrayPlayRooms);

			Ext.create('Ext.data.Store', {
				storeId : 'whattoplay_queue',
				fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
		} catch (e) {
			// alert("WtP initCache "+e.message);
		}
	},
	fillMediaFilesGrid : function(id, lvl) {
		var store;
		var baseArray;
		if (id == null) {

			if (Ext.data.StoreManager.lookup('whattoplay_mediafiles_base') == null) {
				Ext.create('Ext.data.Store', {
					storeId : 'whattoplay_mediafiles_base',
					fields : [ '_id', 'name', 'next', 'icon', 'passive', 'lvl' ],
					proxy : {
						type : 'memory',
						reader : {
							type : 'json',
							root : 'items'
						}
					},
					sorters : [ {
						property : 'name',
						direction : 'ASC'
					} ]
				});
			} else
				Ext.data.StoreManager.lookup('whattoplay_mediafiles_base').removeAll();

			store = Ext.data.StoreManager.lookup('whattoplay_mediafiles_base');
			baseArray = mediaLibrary;
			lvl = 1;
		} else {
			if (Ext.data.StoreManager.lookup('whattoplay_mediafiles_' + lvl) == null) {
				Ext.create('Ext.data.Store', {
					storeId : 'whattoplay_mediafiles_' + lvl,
					fields : [ '_id', 'name', 'next', 'icon', 'passive', 'lvl' ],
					proxy : {
						type : 'memory',
						reader : {
							type : 'json',
							root : 'items'
						}
					},
					sorters : [ {
						property : 'name',
						direction : 'ASC'
					} ]
				});
			} else
				Ext.data.StoreManager.lookup('whattoplay_mediafiles_' + lvl).removeAll();

			store = Ext.data.StoreManager.lookup('whattoplay_mediafiles_' + lvl);
			var oRecSearch = function(oObject, id) {
				if (oObject.id == id)
					return oObject;
				if (oObject.child != null)
					for (var iIndex = 0; iIndex < oObject.child.length; iIndex++) {
						var oRet = oRecSearch(oObject.child[iIndex], id);
						if (oRet != null)
							return oRet;
					}

			}
			baseArray = oRecSearch(mediaLibrary, id);
		}
		store.removeAll();

		for (var iIndex = 0; iIndex < baseArray.child.length; iIndex++) {
			store.add({
				'_id' : baseArray.child[iIndex].id,
				'name' : baseArray.child[iIndex].name,
				'next' : true,
				'passive' : false,
				'lvl' : lvl
			});
		}
		for (var iIndex = 0; iIndex < baseArray.files.length; iIndex++) {
			store.add({
				'_id' : baseArray.files[iIndex].id,
				'name' : baseArray.files[iIndex].name,
				'next' : false,
				'passive' : false,
				'lvl' : lvl
			});
		}
	},
	getSonosDeviceMusic : function(selectedRoom) {
		var me = this;

		me.gridQueue.setVisible(false);
		me.lblNowPlayed.setVisible(true);

		var waitDialog = new Ext.LoadMask(Ext.getBody(), {
			msg : _('Please wait, reading from Sonos device ...')
		});
		waitDialog.show();
		
		if (this.getDeviceMusicCallback==null) {
			this.getDeviceMusicCallback=function(oValue) {
				if (oValue.actions!='getCurrentTitle')
					return;
				var sTitle = _("No music");
				var bWarnOnlySong = false;
				me.selectedSong = null;
				if (oValue.value != null) {
					if (oValue.value == 'error') {
						waitDialog.hide();
						Ext.MessageBox.alert(_('Info'), _("Assigned Sonos Speaker is currently not available."), null);
						return true;
					}
					me.selectedSong = JSON.parse(unescape(oValue.value));
					if (me.selectedSong != null)
						if (me.selectedSong.url != null)
							if (me.selectedSong.url != "") {
								if (me.selectedSong.isRadio) {
									// is a stream									
									sTitle = _("Radio: ");
									for (var iIndex=0;iIndex<playerStore.getCount();iIndex++) {
										var oRecord=playerStore.getAt(iIndex);
										var sString='x-rincon-stream:' + oRecord.get('id')
										if (sString==me.selectedSong.url)
											sTitle = _("Audio Component: ") + oRecord.get('deviceName');
									}
								} else
									sTitle = _("Song: ");
					
								me.bIsRadio = me.selectedSong.isRadio;
	
								if (me.selectedSong.title != null)
									if (me.selectedSong.title != "")
										sTitle += me.selectedSong.title;
									else
										sTitle += '-';
								else
									sTitle += '-';
								if (me.selectedSong.artist != null)
									if (me.selectedSong.artist != "")
										sTitle += " (" + me.selectedSong.artist + ")";
								me.selectedSong.changed = true;
							}
				}
				me.lblNowPlayed.setText(sTitle);

				me.nowFileType = 0;

				me.handleRepeatPreviousMusicControl();

				waitDialog.hide();
				if (bWarnOnlySong)
					Ext.MessageBox.alert(_('Info'), _("Only music with defined length allowed"), null);
				return true;
			}
			fChangedCallback.push(this.getDeviceMusicCallback);
		}
		dss.raiseEvent('sonos.info', {
			actions : 'getCurrentTitle',
			zoneID : selectedRoom});
	},
	getSonosDeviceQueue : function(selectedRoom) {
		var me = this;

		me.gridQueue.setVisible(false);
		me.lblNowPlayed.setVisible(false);

		var waitDialog = new Ext.LoadMask(Ext.getBody(), {
			msg : _('Please wait, reading from Sonos device ...')
		});
		waitDialog.show();

		if (this.getDeviceQueueCallback==null) {
			this.getDeviceQueueCallback=function(oValue) {
				if (oValue.actions!='getCurrentQueue')
					return;
				if (oValue.value != null) {
					if (oValue.value == 'error') {
						waitDialog.hide();
						Ext.MessageBox.alert(_('Info'), _("Assigned Sonos Speaker is currently not available."), null);
						return true;
					}
					me.selectedQueue = JSON.parse(unescape(oValue.value));
					if (me.selectedQueue != null) {
						Ext.data.StoreManager.lookup('whattoplay_queue').removeAll();

						if (me.selectedQueue.length > 0) {
							var arrayFiles = new Array();
							for (var iIndex = 0; iIndex < me.selectedQueue.length; iIndex++) {
								var pos = (iIndex + 1);
								var tmpObj = new Object({
									_id : iIndex,
									name : pos + ". " + unescape(me.selectedQueue[iIndex].title)
								});
								arrayFiles.push(tmpObj);
							}
							Ext.data.StoreManager.lookup('whattoplay_queue').add(arrayFiles);
							me.gridQueue.setVisible(true);
							me.selectedQueue.changed = true;
						} else {
							me.lblNowPlayed.setText(_("Active Queue is empty."));
							me.lblNowPlayed.setVisible(true);
						}
						me.nowFileType = 1;
						me.handleRepeatPreviousMusicControl();
						waitDialog.hide();
						return true;
					}
				}
			}
			fChangedCallback.push(this.getDeviceQueueCallback);
		}
		
		
		dss.raiseEvent('sonos.info', {
			actions : 'getCurrentQueue',
			zoneID : selectedRoom
		});
	},
	constructGridLvlNowPlaying : function(fFromSetValue) {
		try {
			var me = this;
			this.selectedSong = null;
			this.selectedQueue = null;
			this.grids.lvlNowRooms = Ext.create('Ext.grid.Panel', {
				hideHeaders : true,
				height : me.iDefaultHeight,
				width : 160,
				autoScroll : true,
				viewConfig : {
					stripeRows : true
				},
				selModel : {
					mode : 'SINGLE'
				},
				store : Ext.data.StoreManager.lookup('whattoplay_rooms'),
				columns : [ {
					sortable : false,
					hideable : false,
					dataIndex : 'name',
					flex : 1,
					renderer : me.defMacGridRenderer
				} ],
				listeners : {
					selectionchange : function(grid, selected) {
						me.btnGet.setDisabled((selected.length == 0));
						me.btnQueue.setDisabled((selected.length == 0));
					}
				}
			});
			this.grids.lvlNowRooms.parent = this;
			this.macPanel.add(this.grids.lvlNowRooms);

			this.lblNowPlayed = Ext.create('Ext.form.Label', {
				text : "",
				margin : '0 0 2 20',
				cls : 'x-form-item-label',
				id : 'lblNowPlayed'
			});
			this.lblNowPlayed.setVisible(false);

			this.gridQueue = Ext.create('Ext.grid.Panel', {
				hideHeaders : true,
				autoScroll : true,
				width : 400,
				height : 230,
				margin : '5 0 0 20',
				store : Ext.data.StoreManager.lookup('whattoplay_queue'),
				viewConfig : {
					stripeRows : true
				},
				selModel : {
					mode : 'NONE'
				},
				columns : [ {
					sortable : false,
					hideable : false,
					flex : 1,
					renderer : this.defMacGridRenderer
				} ]
			});

			this.gridQueue.setVisible(false);
			this.gridQueue.on('itemclick', function(grid, record) {
				this.getSelectionModel().deselect(record);
			});
			this.gridQueue.setHeight(160);

			this.btnGet = Ext.create('Ext.Button', {
				text : _('Get song'),
				margin : '0 0 2 20',
				handler : function() {
					var selectedRoom = me.grids['lvlNowRooms'].getSelectionModel().getSelection()[0].get('_id');
					me.getSonosDeviceMusic(selectedRoom);
				}
			});
			this.btnQueue = Ext.create('Ext.Button', {
				text : _('Get Active queue'),
				margin : '0 0 2 20',
				handler : function() {
					var selectedRoom = me.grids['lvlNowRooms'].getSelectionModel().getSelection()[0].get('_id');
					me.getSonosDeviceQueue(selectedRoom);
				}
			});
			if (fFromSetValue != null)
				if (fFromSetValue) {
					this.btnGet.setDisabled(true);
					this.btnQueue.setDisabled(true);
				}
			var allButtons = Ext.create('Ext.container.Container', {
				defaultType : 'numberfield',
				items : [ this.btnGet, this.btnQueue ],
				layout : {
					type : 'hbox'
				},
				margin : '5 0 5 0',
				width : 600
			});

			this.grids.lvlNowPlaying = Ext.create('Ext.container.Container', {
				defaultType : 'numberfield',
				items : [ allButtons, me.lblNowPlayed, me.gridQueue ],
				layout : {
					type : 'vbox'
				},
				margin : '5 0 5 0',
				width : 440
			});

			this.grids.lvlNowRooms.on('itemclick', function(grid, record) {
				var oSelectionFavorites = this.getSelectionModel().getSelection();
				me.sSelectedRoomIP = oSelectionFavorites[0].get('playerIP');
				me.macPanel.add(me.grids.lvlNowPlaying);

				me.lblNowPlayed.setVisible(false);
				me.lblNowPlayed.setText("");
				me.selectedSong = null;

				me.gridQueue.setVisible(false);
				me.selectedQueue = null;
				me.handleRepeatPreviousMusicControl();
			});
		} catch (e) {
			// alert("WtP initCache "+e.message);
		}
	},
	constructGridLvlText2Speech : function() {
		try {
			var me = this;
			this.preparePlayButton(true);
			this.comboTextLang = Ext.create('Ext.form.field.ComboBox', {
				store : 'txt2speech_langs',
				queryMode : 'local',
				displayField : 'langName',
				margin : '5 0 0 0',
				valueField : 'langCode',
				fieldLabel : _('Language'),
				labelWidth : 120,
				width : 400,
				listeners : {
					'select' : function(objCombo) {
						if (Ext.data.StoreManager.lookup('txt2speech_voices').getCount()==0)
							return;
						Ext.data.StoreManager.lookup('txt2speech_voices').clearFilter(true);
						Ext.data.StoreManager.lookup('txt2speech_voices').filter([ {
							filterFn : function(item) {
								return (item.get('langCode') == objCombo.getValue());
							}
						} ]);
						me.comboTextVoice.setValue(Ext.data.StoreManager.lookup('txt2speech_voices').getAt(0).get('id'));
					},
					'change' : function(objCombo) {
						if (Ext.data.StoreManager.lookup('txt2speech_voices').getCount()==0)
							return;
						Ext.data.StoreManager.lookup('txt2speech_voices').clearFilter(true);
						Ext.data.StoreManager.lookup('txt2speech_voices').filter([ {
							filterFn : function(item) {
								return (item.get('langCode') == objCombo.getValue());
							}
						} ]);
						me.comboTextVoice.setValue(Ext.data.StoreManager.lookup('txt2speech_voices').getAt(0).get('id'));
					}
				}
			});

			this.comboTextVoice = Ext.create('Ext.form.field.ComboBox', {
				store : Ext.data.StoreManager.lookup('txt2speech_voices'),
				queryMode : 'local',
				displayField : 'name',
				valueField : 'id',
				margin : '5 0 0 0',
				fieldLabel : _('Voice'),
				labelWidth : 120,
				width : 400,
				listeners : {
					'select' : function(objCombo) {
						me.t2sVoiceName = objCombo.getValue();
					},
					'change' : function(objCombo) {
						me.t2sVoiceName = objCombo.getValue();
					}
				}
			});

			// setting default language picker
			if (dss.staticDataModel.activeLanguage != null) {
				this.comboTextLang.setValue(dss.staticDataModel.activeLanguage);
			}
			var sErrorMessage=_('Text is too long. Maximum allowed length is %speechSize characters!').replace('%speechSize',''+maxTextLength);
			this.txt2Speech = Ext.create('Ext.form.field.TextArea', {
				fieldLabel : _("Text to speech"),
				labelWidth : 120,
				margin : '5 0 0 0',
				value : "",
				width : 600,
				height : 140,
				maxLength: maxTextLength,
				maxLengthText:sErrorMessage,
				enforceMaxLength:true
			});
			
			this.txtHint= Ext.create(
					'Ext.form.Label',
					{
						text : _("To use this feature, the my.digitalSTROM app must be configured first."),
						align : 'middle',
						cls : 'x-form-item-label',
						margin : '50 0 0 0',
						width : 550
					});
			
			this.grids.lvlText2Speech = Ext.create('Ext.container.Container', {
				defaultType : 'numberfield',
				items : [ this.comboTextLang, this.comboTextVoice, this.txt2Speech, this.txtHint ],
				layout : {
					type : 'vbox'
				},
				margin : '5 0 0 10',
				width : 600,
				height : 200,
			});

			var bDisable = (Ext.data.StoreManager.lookup('txt2speech_voices').getCount() == 0);

			if (bDisable) {
				this.grids.lvlText2Speech.disable();
				this.preparePlayButton(false);
			}
			
			this.comboTextLang.setVisible(dss.isCloudAvaible());
			this.comboTextVoice.setVisible(dss.isCloudAvaible());
			this.txt2Speech.setVisible(dss.isCloudAvaible());
			this.txtHint.setVisible(!dss.isCloudAvaible());
			this.macPanel.add(this.grids.lvlText2Speech);
		} catch (e) {
			alert("WtP constructGridLvlText2Speech " + e.message);
		}
	},
	constructGridLvlPlaylist : function() {
		this.grids.lvlPlaylist = Ext.create('Ext.grid.Panel', {
			hideHeaders : true,
			height : this.iDefaultHeight,
			width : 624,
			autoScroll : true,
			viewConfig : {
				stripeRows : true
			},
			selModel : {
				mode : 'SINGLE'
			},
			store : Ext.data.StoreManager.lookup('whattoplay_playlists'),
			columns : [ {
				sortable : false,
				hideable : false,
				dataIndex : 'name',
				flex : 1,
				renderer : this.defMacGridRenderer
			} ]
		});

		this.grids.lvlPlaylist.parent = this;

		this.grids.lvlPlaylist.on('itemclick', function(grid, record) {
			if (record.get('_id') == -1) {
				this.getSelectionModel().deselect(record);
			} else {
				this.parent.preparePlayButton(true);
			}
			this.parent.handleRepeatPreviousMusicControl();
		});

		this.macPanel.add(this.grids.lvlPlaylist);

	},
	constructGridLvlFavorites : function() {

		this.grids.lvlFavorites = Ext.create('Ext.grid.Panel', {
			hideHeaders : true,
			height : this.iDefaultHeight,
			width : 624,
			autoScroll : true,
			viewConfig : {
				stripeRows : true
			},
			selModel : {
				mode : 'SINGLE'
			},
			store : Ext.data.StoreManager.lookup('whattoplay_favorites'),
			columns : [ {
				sortable : false,
				hideable : false,
				dataIndex : 'name',
				flex : 1,
				renderer : this.defMacGridRenderer
			} ]
		});

		this.grids.lvlFavorites.parent = this;

		this.grids.lvlFavorites.on('itemclick', function(grid, record) {
			if (record.get('_id') == -1) {
				this.getSelectionModel().deselect(record);
			} else {
				this.parent.preparePlayButton(true);
			}
			this.parent.handleRepeatPreviousMusicControl();
		});

		this.macPanel.add(this.grids.lvlFavorites);
	},
	constructGridMediaSub : function(lvl) {
		var me = this;

		this.grids['lvlMediaGroups' + lvl] = Ext.create('Ext.grid.Panel', {
			hideHeaders : true,
			height : this.iDefaultHeight,
			width : 170,
			autoScroll : true,
			viewConfig : {
				stripeRows : true
			},
			selModel : {
				mode : 'SINGLE'
			},
			store : Ext.data.StoreManager.lookup('whattoplay_mediafiles_' + lvl),
			columns : [ {
				sortable : false,
				hideable : false,
				dataIndex : 'name',
				flex : 1,
				renderer : this.defMacGridRenderer
			} ]
		});

		this.grids['lvlMediaGroups' + lvl].parent = this;
		this.grids['lvlMediaGroups' + lvl].on('selectionchange', function(grid, selection) {
			var oArray = [ 'lvl1', 'lvlMediaGroups' ];
			for (var iIndex = 2; iIndex <= lvl; iIndex++)
				oArray.push('lvlMediaGroups' + iIndex);
			this.parent.clearGridLevels(oArray);
			if (selection.length > 0) {
				var record = selection[0];
				if (record != null && record.get('_id') != null) {
					if (record.get('next')) {
						me.fillMediaFilesGrid(record.get('_id'), record.get('lvl') + 1);
						me.constructGridMediaSub(record.get('lvl') + 1);
						me.value = null;
						me.btnTestPlay.disable();
					} else {
						// leaf
						var oFileObject = getFileObjectFromMedialib(record.get('_id'));
						if (oFileObject != null) {
							me.value = {
								type : 'library',
								contentSrc : oFileObject.url,
								guid : oFileObject.id
							};
							me.btnTestPlay.enable();
						} else {
							me.value = null;
							me.btnTestPlay.disable();
						}
					}
				}
			}
		});
		this.macPanel.add(this.grids['lvlMediaGroups' + lvl]);

		var lvlPast = lvl;
		while (this.grids['lvlMediaGroups' + lvlPast] != null) {
			this.grids['lvlMediaGroups' + lvlPast].hide();
			lvlPast += 1;
		}
		this.preparePlayButton(false);
		this.handleRepeatPreviousMusicControl();
		this.grids['lvlMediaGroups' + lvl].show();

		return this.grids['lvlMediaGroups' + lvl];
	},
	constructGridLvlMediaLib : function() {
		try {
			var me = this;
			this.fillMediaFilesGrid();

			this.grids.lvlMediaGroups = Ext.create('Ext.grid.Panel', {
				hideHeaders : true,
				height : this.iDefaultHeight,
				width : 170,
				autoScroll : true,
				viewConfig : {
					stripeRows : true
				},
				selModel : {
					mode : 'SINGLE'
				},
				store : Ext.data.StoreManager.lookup('whattoplay_mediafiles_base'),
				columns : [ {
					sortable : false,
					hideable : false,
					dataIndex : 'name',
					flex : 1,
					renderer : this.defMacGridRenderer
				} ]
			});

			this.grids.lvlMediaGroups.parent = this;
			this.grids.lvlMediaGroups.on('selectionchange', function(grid, selection) {
				this.parent.clearGridLevels([ 'lvl1', 'lvlMediaGroups' ]);
				if (selection.length > 0) {
					var record = selection[0];
					if (record != null && record.get('_id') != null) {
						if (record.get('next')) {
							me.fillMediaFilesGrid(record.get('_id'), record.get('lvl') + 1);
							me.constructGridMediaSub(record.get('lvl') + 1);
							me.btnTestPlay.disable();
							me.value = null;
						} else {
							// leaf
							var oFileObject = getFileObjectFromMedialib(record.get('_id'));
							if (oFileObject != null) {
								me.value = {
									type : 'library',
									contentSrc : oFileObject.url,
									guid : oFileObject.id
								};
								me.btnTestPlay.enable();
							} else {
								me.value = null;
								me.btnTestPlay.disable();
							}

						}
						me.preparePlayButton(false);
						me.handleRepeatPreviousMusicControl();
					}
				}
			});
			if (!dss.isCloudAvaible())
				this.grids.lvlMediaGroups = Ext.create(
					'Ext.form.Label',
					{
						text : _("To use this feature, the my.digitalSTROM app must be configured first."),
						align : 'middle',
						cls : 'x-form-item-label',
						margin : '50 0 0 20',
						width : 550
					});
			

			this.macPanel.add(this.grids.lvlMediaGroups,this.libHint);

		} catch (e) {

		}
	},
	constructGridLvlCommands : function() {
		var me = this;

		this.grids.lvlCommands = Ext.create('Ext.grid.Panel', {
			hideHeaders : true,
			height : this.iDefaultHeight,
			width : 624,
			autoScroll : true,
			viewConfig : {
				stripeRows : true
			},
			selModel : {
				mode : 'SINGLE'
			},
			store : Ext.data.StoreManager.lookup('whattoplay_commands'),
			columns : [ {
				sortable : false,
				hideable : false,
				dataIndex : 'name',
				flex : 1,
				renderer : this.defMacGridRenderer
			} ]
		});

		this.grids.lvlCommands.parent = this;

		this.grids.lvlCommands.on('itemclick', function(grid, record) {
			if (record.get('_id') == -1) {
				this.getSelectionModel().deselect(record);
			} else
				me.preparePlayExtraControls(record.get('_id'));
		});

		this.macPanel.add(this.grids.lvlCommands);

	},
	constructMacGrids : function() {

		var me = this;

		if (this.grids.lvl1 != null)
			this.clearGridLevels([ 'lvl1' ]);
		else {
			this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
				hideHeaders : true,
				height : this.iDefaultHeight,
				width : this.iDefaultWidth,
				autoScroll : true,
				viewConfig : {
					stripeRows : true
				},
				selModel : {
					mode : 'SINGLE'
				},
				store : Ext.data.StoreManager.lookup('whattoplay_lvl1'),
				columns : [ {
					sortable : false,
					hideable : false,
					dataIndex : 'name',
					flex : 1,
					renderer : this.defMacGridRenderer
				} ]
			});
			this.grids.lvl1.getSelectionModel().store = this.grids.lvl1.store;
			this.grids.lvl1.parent = this;

			this.grids.lvl1.on('itemclick', function(grid, record) {
				this.parent.clearGridLevels([ 'lvl1' ]);
				this.parent.nowFileType = -1;
				this.parent.preparePlayButton(false);

				var fIsPassive = false;
				if (record.get('passive') != null) {
					if (record.get('passive') == true) {
						this.getSelectionModel().deselect(record);
						fIsPassive = true;
					}
				}
				this.parent.preparePlayExtraControls(-1);

				if (this.parent.value!=null) {
					this.parent.value.contentSrc = null;
					this.parent.value.guid = null;
				}
				if (!fIsPassive) {
					if (record.get('_id') == 0) { // nowPlaying
						this.parent.constructGridLvlNowPlaying();
						this.getSelectionModel().deselectAll();
						this.getSelectionModel().select(record);
					} else if (record.get('_id') == 1) { // playlist
						this.parent.constructGridLvlPlaylist();
						this.getSelectionModel().deselectAll();
						this.getSelectionModel().select(record);
					} else if (record.get('_id') == 2) { // favorites
						this.parent.constructGridLvlFavorites();
						this.getSelectionModel().deselectAll();
						this.getSelectionModel().select(record);
					} else if (record.get('_id') == 3) { // Media
						// lib
						this.parent.constructGridLvlMediaLib();
						this.getSelectionModel().deselectAll();
						this.getSelectionModel().select(record);
						var sRemoteWarning = this.parent.getRemoteErrorText(this.parent.arrayMediaLibrary);
						if (sRemoteWarning != "") {
							Ext.MessageBox.alert(_('Info'), sRemoteWarning, null);
						}
					} else if (record.get('_id') == 4) { // Text2Speech
						this.parent.constructGridLvlText2Speech();
						this.getSelectionModel().deselectAll();
						this.getSelectionModel().select(record);

						var sRemoteWarning = this.parent.getRemoteErrorText(this.parent.arraySpeechSettings);
						if (sRemoteWarning != "") {
							Ext.MessageBox.alert(_('Info'), sRemoteWarning, null);
						}
					} else if (record.get('_id') == 5) { // commands
						this.parent.constructGridLvlCommands();
						this.getSelectionModel().deselectAll();
						this.getSelectionModel().select(record);
					}
					this.parent.nActionType = record.get('_id');
				}
				this.parent.handleRepeatPreviousMusicControl();
			});
		}

		Ext.data.StoreManager.lookup('whattoplay_lvl1').removeAll();

		Ext.data.StoreManager.lookup('whattoplay_l1Store_' + this.parentDialog).each(function(record) {
			var oNewRecord = record.copy();
			Ext.data.StoreManager.lookup('whattoplay_lvl1').add(oNewRecord);
		});

		if (!this.macPanel.contains(this.grids.lvl1, true))
			this.macPanel.add(this.grids.lvl1);

	},
	constructor : function(config) {
		this.iDefaultHeight = 220;
		this.macPanel = Ext.create('Ext.panel.Panel', {
			border : '0',
			autoScroll : true,
			height : this.iDefaultHeight + 2,
			layout : {
				type : 'hbox'
			},
			items : [],// this.grids.lvl1
			scroll : 'horizontal'
		});

		var me = this;
		var rowRestart = null;
		this.checkVolume = Ext.create('Ext.form.field.Checkbox', {
			fieldLabel : "",
			align : 'middle',
			listeners : {
				'change' : function(checkbox, newVal, oldVal) {
					me.intVolume.setDisabled(!newVal);
					if (newVal)
						if (me.intVolume.getValue()==null)
							me.intVolume.setValue(10);
				}
			}
		});

		var lblSetVolume = Ext.create('Ext.form.Label', {
			text : _("Set volume to"),
			align : 'middle',
			cls : 'x-form-item-label',
			margin : '0 0 0 10'
		});

		this.intVolume = Ext.create('Ext.form.field.Number', {
			fieldLabel : "",
			margin : '0 0 0 10',
			width : 50,
			step : 1,
			value : 0,
			minValue : 0,
			maxValue : 100
		});

		var lblSetVolume2 = Ext.create('Ext.form.Label', {
			text : "%",
			align : 'middle',
			cls : 'x-form-item-label',
			margin : '0 0 0 2'
		});

		this.rowVolume = Ext.create('Ext.container.Container', {
			defaultType : 'numberfield',
			items : [ this.checkVolume, lblSetVolume, this.intVolume, lblSetVolume2 ],
			layout : 'column',
			margin : '5 0 5 10',
			width : 650
		});
		this.bVolumeRowIsEnabled = true;

		/* REPEAT MUSIC */
		this.checkRepeat = Ext.create('Ext.form.field.Checkbox', {
			fieldLabel : "",
			align : 'middle',
			listeners : {
				'change' : function(checkbox, newVal, oldVal) {
					if (newVal > 0 && me.timeSpanRepeat.getValue() < 1) {
						me.timeSpanRepeat.setValue(1);
					}
					me.handleRepeatPreviousMusicControl();
					me.timeSpanRepeat.setDisabled(!newVal);
				}
			}
		});

		var lblRepeat = Ext.create('Ext.form.Label', {
			text : _("Repeat music for maximum of"),
			align : 'middle',
			cls : 'x-form-item-label',
			margin : '0 0 0 10'
		});

		this.timeSpanRepeat = Ext.create('Ext.form.field.Number', {
			fieldLabel : "",
			margin : '0 0 0 10',
			width : 50,
			step : 1,
			value : 0,
			minValue : 1,
			maxValue : 10
		});

		var lblRepeat2 = Ext.create('Ext.form.Label', {
			text : _("minutes"),
			align : 'middle',
			cls : 'x-form-item-label',
			margin : '0 0 0 5'
		});

		this.rowRepeat = Ext.create('Ext.container.Container', {
			defaultType : 'numberfield',
			items : [ this.checkRepeat, lblRepeat, this.timeSpanRepeat, lblRepeat2 ],
			layout : 'column',
			margin : '5 0 5 10',
			width : 650
		});

		/* RESTART MUSIC */
		this.checkRestart = Ext.create('Ext.form.field.Checkbox', {
			fieldLabel : "",
			align : 'right',
			listeners : {
				'change' : function(checkbox, newVal, oldVal) {
				}
			}
		});

		var lblRestart = Ext.create('Ext.form.Label', {
			text : _("Restart previous music once finished"),
			align : 'middle',
			cls : 'x-form-item-label',
			margin : '0 0 0 10'
		});

		this.rowRestart = Ext.create('Ext.container.Container', {
			defaultType : 'numberfield',
			items : [ this.checkRestart, lblRestart ],
			layout : 'column',
			margin : '5 0 5 10',
			width : 650
		});

		this.btnTestPlay = Ext.create('Ext.Button', {
			text : _("Play"),
			iconCls : 'icon-start-test-play',
			width : 115,
			margin : '5 0 0 0',
			handler : function() {
				var oAction = me.getValue();
				var oTarget = me.dssEditor.editControls.target.getValue();
				oAction.maxDuration=10;
				var parameter = {
					actions : 'temporaryPlay',
					value : Ext.JSON.encode({
						action : oAction,
						target : oTarget
					})
				};
				dss.raiseEvent('sonos.config', parameter);

				return;
			}
		});
		this.btnTestPlay.disable();

		var oTabPanelL = Ext.create('Ext.panel.Panel', {
			border : false,
			defaults : {
				style : {
					float : 'left'
				}
			},
			items : [ this.rowVolume, this.rowRepeat, this.rowRestart ],
			width : 640
		});
		var oTabPanelR = Ext.create('Ext.panel.Panel', {
			border : false,
			defaults : {
				style : {
					float : 'right'
				}
			},
			items : [ this.btnTestPlay ],
			width : 120
		});
		this.grids.pnlExtraFields = Ext.create('Ext.container.Container', {
			defaultType : 'numberfield',
			items : [ oTabPanelL, oTabPanelR ],
			layout : 'column',
			margin : '5 0 5 0',
			width : 760
		});

		Ext.apply(this, {
			items : [ this.macPanel, this.grids.pnlExtraFields ]
		});

		this.callParent(arguments);
	},
	clearGridLevels : function(idsNotToRemove) {
		if (idsNotToRemove == null)
			idsNotToRemove = [];
		for ( var sKey in this.grids)
			if (idsNotToRemove.indexOf(sKey) < 0)
				this.macPanel.remove(this.grids[sKey]);
	},
	reset : function() {
		try {
			me = this;
			this.nowFileType = -1;

			this.initLvl1();
			this.constructMacGrids();
			this.initStores();

			this.checkVolume.setValue(false);
			this.intVolume.setValue(null);
			this.intVolume.setDisabled(true);
			this.checkRepeat.setValue(false);
			this.timeSpanRepeat.setValue(null);
			this.timeSpanRepeat.setDisabled(true);
			this.checkRestart.setValue(false);

			this.preparePlayExtraControls(-1);
			this.grids.lvl1.getSelectionModel().deselectAll();

			
			this.value.contentSrc = null;
			this.value.guid = null;
			this.value.text = null;
			this.value.voice_id = null;
			
			// handling trigger selection item
			this.dssEditor.editControls.triggers.grids.lvl1.on('itemclick', function(grid, record) {
				me.handleRepeatPreviousMusicControl();
				if (me.dssEditor.editControls.triggers.grids.lvlPanic != null) {
					me.dssEditor.editControls.triggers.grids.lvlPanic.on('itemclick', function(grid, record) {
						me.handleRepeatPreviousMusicControl();
					});
				}
			});
			this.handleRepeatPreviousMusicControl();
		} catch (e) {
			// alert("WtP reset "+e.message);
		}
	},
	setValue : function(values) {
		try {
			this.initLvl1();
			this.constructMacGrids();
			this.initStores();
			
			switch (values.type) {

			case 'command':
				var oRecord = this.grids.lvl1.store.find('_id', 5, false, false, true);
				this.grids.lvl1.getSelectionModel().select(oRecord, true);
				this.constructGridLvlCommands();
				var oRecordCommand = this.grids.lvlCommands.store.find('_id', values.command, 0, false, false, true);
				if (oRecordCommand != -1) {
					this.grids.lvlCommands.getSelectionModel().select(oRecordCommand);
				}
				break;
			case 'playlist':
				var oRecord = this.grids.lvl1.store.find('_id', 1, false, false, true);
				this.grids.lvl1.getSelectionModel().select(oRecord, true);
				this.constructGridLvlPlaylist();
				var oRecordPlaylist = Ext.data.StoreManager.lookup('whattoplay_playlists').find('listUrl', values.contentSrc, 0, false, false, true);
				if (oRecordPlaylist != -1) {
					this.grids.lvlPlaylist.getSelectionModel().select(oRecordPlaylist);
				}
				break;
			case 'favorite':
				var oRecord = this.grids.lvl1.store.find('_id', 2, false, false, true);
				this.grids.lvl1.getSelectionModel().select(oRecord, true);
				this.constructGridLvlFavorites();
				var oRecordFavorites = Ext.data.StoreManager.lookup('whattoplay_favorites').find('listUrl', values.contentSrc, 0, false, false, true);
				if (oRecordFavorites != -1) {
					this.grids.lvlFavorites.getSelectionModel().select(oRecordFavorites);
				}
				break;
			case 'plainSong':
				var oRecord = this.grids.lvl1.store.find('_id', 0, false, false, true);
				this.grids.lvl1.getSelectionModel().select(oRecord, true);
				this.constructGridLvlNowPlaying(true);
				this.macPanel.add(this.grids.lvlNowPlaying);
				this.lblNowPlayed.setVisible(true);

				this.selectedSong = {
					isRadio : false,
					title : dss.unescapeProperty(values.info.title),
					url : values.contentSrc
				};
				if (values.info.artist != null)
					this.selectedSong.artist = dss.unescapeProperty(values.info.artist);
				if (values.metaData != null)
					this.selectedSong.metaData = dss.unescapeProperty(values.metaData);

				if (values.info.length != null)
					this.selectedSong.length =values.info.length;

				var sTitle = _("Song: ");
				if (this.selectedSong.title != null)
					if (this.selectedSong.title != "")
						sTitle += this.selectedSong.title;
				if (this.selectedSong.artist != null)
					if (this.selectedSong.artist != "")
						sTitle += " (" + this.selectedSong.artist + ")";
				this.lblNowPlayed.setText(sTitle);

				this.gridQueue.setVisible(false);
				this.selectedQueue = null;
				this.handleRepeatPreviousMusicControl();

				break;
			case 'plainRadio':
				var oRecord = this.grids.lvl1.store.find('_id', 0, false, false, true);
				this.grids.lvl1.getSelectionModel().select(oRecord, true);
				this.constructGridLvlNowPlaying(true);
				this.macPanel.add(this.grids.lvlNowPlaying);
				this.lblNowPlayed.setVisible(true);
				this.selectedSong = {
					isRadio : true,
					title : dss.unescapeProperty(values.info.title),
					url : values.contentSrc
				};
				if (values.info.artist != null)
					this.selectedSong.artist = dss.unescapeProperty(values.info.artist);
				if (values.metaData != null)
					this.selectedSong.metaData = dss.unescapeProperty(values.metaData);

				var sTitle = _("Radio: ");
				if (this.selectedSong.title != null)
					if (this.selectedSong.title != "")
						sTitle += this.selectedSong.title;
				if (this.selectedSong.artist != null)
					if (this.selectedSong.artist != "")
						sTitle += " (" + this.selectedSong.artist + ")";
				this.lblNowPlayed.setText(sTitle);
				this.nowFileType = 0;
				this.gridQueue.setVisible(false);
				this.selectedQueue = null;
				this.handleRepeatPreviousMusicControl();
				break;
			case 'plainQueue':
				var oRecord = this.grids.lvl1.store.find('_id', 0, false, false, true);
				this.grids.lvl1.getSelectionModel().select(oRecord, true);
				this.constructGridLvlNowPlaying(true);
				this.macPanel.add(this.grids.lvlNowPlaying);
				this.lblNowPlayed.setVisible(false);
				this.lblNowPlayed.setText("");
				this.selectedSong = null;
				this.gridQueue.setVisible(true);
				this.selectedQueue = [];
				for ( var sKey in values.queue) {
					this.selectedQueue.push({
						playID : values.queue[sKey].contentSrc,
						title : dss.unescapeProperty(values.queue[sKey].title),
						trackPos : values.queue[sKey].pos
					});
				}

				if (this.selectedQueue.length > 0) {
					var arrayFiles = new Array();
					for (var iIndex = 0; iIndex < this.selectedQueue.length; iIndex++) {
						var pos = (iIndex + 1);
						var tmpObj = new Object({
							_id : iIndex,
							name : pos + ". " + dss.unescapeProperty(unescape(this.selectedQueue[iIndex].title))
						});
						arrayFiles.push(tmpObj);
					}
					Ext.data.StoreManager.lookup('whattoplay_queue').add(arrayFiles);
					this.gridQueue.setVisible(true);
					this.selectedQueue.changed = true;
				} else {
					this.lblNowPlayed.setText(_("Active Queue is empty."));
					this.lblNowPlayed.setVisible(true);
				}
				this.nowFileType = 1;

				this.handleRepeatPreviousMusicControl();
				break;
			case 'library':
				var oRecord = this.grids.lvl1.store.find('_id', 3, false, false, true);
				this.grids.lvl1.getSelectionModel().select(oRecord, true);
				this.constructGridLvlMediaLib();
				var oFileObject = getFileObjectFromMedialib(values.guid);
				var path = [ oFileObject, oFileObject.base ];
				while (path[path.length - 1].parent != null) {
					path.push(path[path.length - 1].parent);
				}

				var iIndex = this.grids.lvlMediaGroups.store.find('_id', path[path.length - 2].id, false, false, true)
				this.grids.lvlMediaGroups.getSelectionModel().select(iIndex, true);

				for (var iIndex = (path.length - 3); iIndex >= 0; iIndex--) {
					var itemID = path[iIndex].id;
					var actualGrid = this.grids['lvlMediaGroups' + (path.length - iIndex - 1)];
					var oRecordIndex = actualGrid.store.find('_id', itemID, false, false, true);
					actualGrid.getSelectionModel().select(oRecordIndex, true);
				}
				break;
			case 'text2speech':
				var oRecord = this.grids.lvl1.store.find('_id', 4, false, false, true);
				this.grids.lvl1.getSelectionModel().select(oRecord, true);
				this.constructGridLvlText2Speech();

				if (values.contentSrc != null) {
					this.value = {
						contentSrc : values.contentSrc,
						guid : values.guid,					 
					};
				}
				this.value.text = unescape(values.info.text);
				this.value.voice_id = values.info.voice_id;
				
				var baseLang=Ext.data.StoreManager.lookup('txt2speech_voices_base').findRecord('id', values.info.voice_id, false, false, true);
				this.comboTextLang.setValue(baseLang.get('langCode'));
				
				this.comboTextVoice.setValue(values.info.voice_id);

				this.txt2Speech.setValue(unescape(values.info.text));
				break;
			}

			this.handleRepeatPreviousMusicControl();
			
			if (values.volume != null) {
				this.checkVolume.setValue(true);
				this.intVolume.setValue(values.volume);
			} else {
				this.checkVolume.setValue(false);
				this.intVolume.setValue(null);
			}

			this.checkRepeat.setValue(false);
			this.timeSpanRepeat.setValue(0);
			this.checkRestart.setValue(false);
			if (values.restartAfter!=null)
				this.checkRestart.setValue(values.restartAfter);
			
			this.checkRepeat.setValue(values.loopingTimespan>0);
			this.timeSpanRepeat.setValue(Math.floor(values.loopingTimespan/60));
			
		} catch (e) {
			// alert("WtP setValue "+e.message);
		}
	},
	isValid : function() {
		var bValid = true;
		var bCheckFileLength = true;

		var oSelectionLVL1 = this.grids.lvl1.getSelectionModel().getSelection()[0];

		if (this.checkVolume.getValue()) {
			if (!this.intVolume.isValid())
			{
				Ext.MessageBox.alert(_('Info'), _("Invalid volume value!"), null);
				return false;
			}
		}
		
		switch (oSelectionLVL1.get('_id')) { // media library
		case 0:
			if (this.selectedSong != null)
				return true;
			if (this.selectedQueue != null)
				if (this.selectedQueue.length > 0)
					return true;
			return false;
			break;
		case 1:
			var oSelectionPlaylist = this.grids.lvlPlaylist.getSelectionModel().getSelection();
			return (oSelectionPlaylist.length == 1);
			break;
		case 2:
			var oSelectionFavorites = this.grids.lvlFavorites.getSelectionModel().getSelection();
			return (oSelectionFavorites.length == 1);
			break;
		case 3:
			if (this.value != null)
				if (this.value.guid != null)
					return true;
			return false;
			break;
		case 4:
			if (!this.comboTextVoice.isValid())
				return false;
			if (!this.txt2Speech.isValid())
				return false;
			return true;
			break;
		case 5:
			var oSelectionCommand = this.grids.lvlCommands.getSelectionModel().getSelection();
			return (oSelectionCommand.length == 1);
			break;
		}

		return false;

		if (bCheckFileLength) {
			var nTime = parseInt("" + this.timeSpanRepeat.getValue(), 10);
			if (bValid && this.checkRepeat.checked && nTime == 0) {
				Ext.MessageBox.alert(_('Info'), _("Repeated time in minutes is missing!"), null);
				bValid = false;
			}

			if (bValid && this.checkRepeat.checked && (nTime < 1 || nTime > 10)) {
				Ext.MessageBox.alert(_('Info'), _("Repeated time in minutes is invalid. Only allowed values between 1 and 10!"), null);
				bValid = false;
			}
		}

		if (bValid && (oSelectionLVL1[0].get('_id') == 4)) {
			Ext.MessageBox.alert(_('Info'), _("Repeated time in minutes is invalid. Only allowed values between 1 and 10!"), null);
			switch (nError) {
			case 79:
				Ext.MessageBox.alert(_('Info'), _("The maximal number of created text messages per day was exceeded. Please try again tomorrow."), null);
				break;

			default:
				Ext.MessageBox.alert(_('Info'), _("Cannot create Text to speech file."), null);
				break;
			}
			bValid = false;
		}

		if (bValid) // test if grouping
			// is allowed,
			// testing here so
			// that we do not
			// show more than
			// one alert at the
			// time to user
			this.dssEditor.editControls.selectedRoom.isGroupingAllowed(true, false);

		return bValid;
	},
	getValue : function() {
		var returnValue = {};
		try {
			var oSelectionLVL1 = this.grids.lvl1.getSelectionModel().getSelection()[0];
			switch (this.grids.lvl1.getSelectionModel().getSelection()[0].get('_id')) {
			case 0:
				if (this.nowFileType == 0) {
					if (this.selectedSong.isRadio) {
						returnValue.type = 'plainRadio';
						returnValue.restoreAfter = false;
					} else {
						returnValue.type = 'plainSong';
						returnValue.restoreAfter = true;
					}
					returnValue.contentSrc = this.selectedSong.url;
					returnValue.info = {};
					if (this.selectedSong.title != null)
						if (this.selectedSong.title != "")
							returnValue.info.title = this.selectedSong.title;
					if (this.selectedSong.artist != null)
						if (this.selectedSong.artist != "")
							returnValue.info.artist = this.selectedSong.artist;
					if (this.selectedSong.metaData != null)
						if (this.selectedSong.metaData != "")
							returnValue.metaData = this.selectedSong.metaData;
					if (this.selectedSong.length != null)
						if (this.selectedSong.length > 0)
							returnValue.info.length = this.selectedSong.length;
				} else {
					returnValue.type = 'plainQueue';
					returnValue.content = [];
					returnValue.restoreAfter = true;
					for (var iIndex = 0; iIndex < this.selectedQueue.length; iIndex++) {
						returnValue.content.push({
							contentUrl : this.selectedQueue[iIndex].playID,
							title : this.selectedQueue[iIndex].title,
							pos : this.selectedQueue[iIndex].trackPos
						});
					}
				}
				break;
			case 1:
				var oSelectionPlaylist = this.grids.lvlPlaylist.getSelectionModel().getSelection();
				returnValue.type = 'playlist';
				returnValue.contentSrc = oSelectionPlaylist[0].get('listUrl');
				returnValue.metaData = escape(oSelectionPlaylist[0].get('metaData'));
				returnValue.restoreAfter = this.checkIfSelectedItemIsSingleFile();
				break;
			case 2:
				var oSelectionFavorites = this.grids.lvlFavorites.getSelectionModel().getSelection();
				returnValue.type = 'favorite';
				returnValue.contentSrc = oSelectionFavorites[0].get('listUrl');
				//if (returnValue.contentSrc.indexOf('x-sonosapi-stream')!=-1)
					returnValue.metaData = escape(oSelectionFavorites[0].get('metaData'));
				returnValue.restoreAfter = this.checkIfSelectedItemIsSingleFile();
				break;
			case 3:
				returnValue.type = 'library';
				returnValue.contentSrc = this.value.contentSrc;
				returnValue.guid = this.value.guid;
				returnValue.restoreAfter = true;
				break;
			case 4:
				returnValue.type = 'text2speech';
				
				var fNewRender=true;
				if (this.value!=null)
					if (this.value.text!=null)
						if (this.value.text==this.txt2Speech.getValue())
							if (this.value.voice_id!=null)
								if (this.value.voice_id==this.comboTextVoice.getValue())
									fNewRender=false;
				
				if (!fNewRender)
					if (this.value != null) {
						if (this.value.contentSrc != null)
							returnValue.contentSrc = this.value.contentSrc;
						if (this.value.guid != null)
							returnValue.guid = this.value.guid;
					}
				returnValue.voice_id = this.comboTextVoice.getValue();
				returnValue.text = (this.txt2Speech.getValue());
				returnValue.restoreAfter = true;
				break;
			case 5:
				var oSelectionCommand = this.grids.lvlCommands.getSelectionModel().getSelection();
				returnValue.type = 'command';
				returnValue.command = oSelectionCommand[0].get('_id');
				break;
			}

			if (this.checkVolume.getValue())
				returnValue.volume = this.intVolume.getValue();

			if (this.checkRepeat.checked)
				returnValue.loopingTimespan = this.timeSpanRepeat.getValue() * 60;

			if (this.checkRestart.checked) {
				returnValue.restoreAfter = true;
				returnValue.restartAfter = true;
			}
				
		} catch (e) {
			// alert("WtP getValue "+e.message);
		}

		return returnValue;
	}
});
